unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Spin, StdCtrls;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Button1: TButton;
    SpinEdit1: TSpinEdit;
    procedure Button1Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

// Ce programme value les termes conscutifs des suites u et v dfinies
// par rcurrence par :
// u(0)=1, v(0)=2 et, pour tout entier naturel n :
// u(n+1)=3u(n)+2v(n)
// v(n+1)=2u(n)+3v(n)
// Remarque : la suite u-v est constante gale  1

{$R *.DFM}

function v(n:integer):int64; forward;

function u(n:integer):int64;
begin
     if n=0 then result:=1  //condition de sortie de la rcursion
     else result:=3*u(n-1)+2*v(n-1);
end;

function v;
begin
     if n=0 then result:=2  //condition de sortie de la rcursion
     else result:=2*u(n-1)+3*v(n-1);
end;

procedure TForm1.Button1Click(Sender: TObject);
var i:integer;
begin
     Screen.Cursor:=crHourGlass;
     Memo1.Clear;
     for i:=0 to SpinEdit1.Value-1 do
         begin
         Memo1.Lines.Add('u('+IntToStr(i)+') = '+IntToStr(u(i)));
         Memo1.Lines.Add('v('+IntToStr(i)+') = '+IntToStr(v(i)));
         Memo1.Lines.Add(' ');
         end;
     Screen.Cursor:=crDefault;
end;

end.
 